<%--
Copyright (C) 2004-2007 by Autodesk, Inc.
This library is free software; you can redistribute it and/or
modify it under the terms of version 2.1 of the GNU Lesser
General Public License as published by the Free Software Foundation.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
--%>

<%@ Import Namespace="System" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Collections.Specialized" %>
<%@ Import Namespace="System.Text" %>

<!-- #Include File="common.aspx -->

<script runat="server">
String mapName = "";
String sessionId = "";
</script>

<%
    Response.Charset = "utf-8";
    MgLocalizer.SetLocalizedFilesPath(Request.ServerVariables["APPL_PHYSICAL_PATH"] + "..\\localized\\");

    GetRequestParameters();

    InitializeWebTier();

    // connect to the site and get a resource service instance
    MgUserInformation cred = new MgUserInformation(sessionId);
    MgSiteConnection site = new MgSiteConnection();
    site.Open(cred);

    MgResourceService resourceSrvc = site.CreateService(MgServiceType.ResourceService) as MgResourceService;

    // load the map runtime state
    MgMap map = new MgMap();
    map.Open(resourceSrvc, mapName);

    // toggle the legend visibility of some of the layers
    MgLayerCollection layers = map.GetLayers();
    int numLayers = layers.GetCount();
    if (numLayers > 4)
    {
        MgLayerBase layer1 = layers.GetItem(1);
        bool display1 = layer1.GetDisplayInLegend();
        layer1.SetDisplayInLegend(!display1);

        MgLayerBase layer4 = layers.GetItem(4);
        bool display4 = layer4.GetDisplayInLegend();
        layer4.SetDisplayInLegend(!display4);
    }

    // toggle the legend visibility of some of the groups
    MgLayerGroupCollection groups = map.GetLayerGroups();
    int numGroups = groups.GetCount();
    if (numGroups > 0)
    {
        MgLayerGroup group0 = groups.GetItem(0);
        bool display0 = group0.GetDisplayInLegend();
        group0.SetDisplayInLegend(!display0);

        MgLayerGroup group2 = groups.GetItem(2);
        group2.SetLegendLabel("New Legend Label");
    }

    map.Save(resourceSrvc);

    String msg = "<html>\n"
               + "<head>\n"
               + "  <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n"
               + "  <script language=javascript>\n"
               + "  function InitDocument()\n"
               + "  {\n"
               + "    parent.parent.Refresh();\n"
               + "  }\n"
               + "  </script>\n"
               + "</head>\n"
               + "<body onload=\"InitDocument()\">\n"
               + "  Layer and layer group legend visibilities have been toggled...\n"
               + "</body>\n"
               + "</html>\n";
    Response.Write(msg);
%>

<script runat="server">

void GetRequestParameters()
{
    if(Request.HttpMethod == "POST")
        GetParameters(Request.Form);
    else
        GetParameters(Request.QueryString);
}

void GetParameters(NameValueCollection parameters)
{
    mapName = GetParameter(parameters, "MAPNAME");
    sessionId = GetParameter(parameters, "SESSION");
}

</script>
